-- 开服狂欢优化
Lua_OpenServerCarnivalWindow = class("Lua_OpenServerCarnivalWindow", Lua_Window);
function Lua_OpenServerCarnivalWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showBackBtn = true;
    self.isFullSizeWin = true;
    self.isFullPaving = true;
    self.showWinBg = true;

    -- self.winBgPath = "/images/common/ui_common_window_016.png"; 
    self.showBlackMask = true;
    self.windowName = "Lua_OpenServerCarnivalWindow";
    self.skinName = "OpenServerCarnivalWindow_skin";

    self.firstWinBgPath = "/images/openServer/xui_qrmb_bg_002.jpg"
    self.secondWinBgPath = "/images/openServer/xui_qrmb_bg_001.jpg";
    self.winBgPath = self.firstWinBgPath;

    self:addPreLoadRes(self.firstWinBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes(self.secondWinBgPath, Lua_LoadFileType.IMG);
end

function Lua_OpenServerCarnivalWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.taskBg:SetDimensions(689, 673 + self.adaptHeight);
	self.totalProgressBar.typeValue = 3;
    self.totalProgressBar.fillMethodValue = 0;
    self.totalProgressBar.fillOrigin = 0;

	-- 底部页签栏
	self:createBottomTabList();
	self:setProcessZeroValue();

	self.backBtn:setLocation(62, 52);

	-- 最终奖励
	self.finishReward = Lua_OpenServerCarnivalRewardCell.new(self.content);
	self.finishReward.content.name = "finishRewards";
	self.finishReward:setLocation(254, -343);
	self.finishReward:setRectAnchor(1);

	-- 每天奖励
	self.dayReward = Lua_OpenServerCarnivalRewardCell.new(self.content);
	self.dayReward.content.name = "dayReward";
	self.dayReward:setLocation(239, 208);
	self.dayReward:setRectAnchor(7);

	-- 天数按钮
	self.dayButtons = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal, true, 670, 65);
	self.dayButtons.content.name = "dayButtons";
    -- self.dayButtons:setRectPivot(3);
    self.dayButtons:setRectAnchor(1);
    self.dayButtons:setLocation(2, -439, 0);
    self.dayButtons:setButtonCell(Lua_OpenServerCarnivalBtnCell);
    self.dayButtons:setButtonItem(140, 65);
    self.dayButtons:setClickCallBack(self, self.onClickDayBtn);

	-- 任务列表
	self.itemList = Lua_DragList.new(self.content, 665, 647 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_OpenServerCarnivalTaskCell, 665, 142, 1);
	self.itemList:setLocation(-1, -84);
	local tweenId = getConfig({"open_carnival_reward", "tween", "tweenId" });
	self.itemList.tweenId = tweenId;

	self:addLuaEvent("UPDATE_OPENSERVERCARNIVAL_INFO", self, self.updateServerInfo);
	self:addLuaEvent("UPDATE_DAYTASK_INFO", self, self.updateDayTask);

	Lua_ProxyManager.getProxy("Lua_OpenServerCarnivalProxy"):sOpenServerCarnivalInfo();
end


function Lua_OpenServerCarnivalWindow:onClickDayBtn(index)
	if self.selectedDay == index then
		return;
	end

	self.selectedDay = index;
	local dayIdList = DataCenter.openServerCarnivalData:getDayIdListByTab(self.actIndex);
	self:updateDayTask(dayIdList[self.selectedDay], true);
end

function Lua_OpenServerCarnivalWindow:setProcessZeroValue()
	-- 总进度
    self.totalProgressBar:setValue(0);
	self.totalProgressBar:setMaxValue(0);
	-- 该天进度
    self.dayProgressBar:setValue(0);
    self.dayProgressBar:setMaxValue(0);
end

-- 创建底部页签buttonList
function Lua_OpenServerCarnivalWindow:createBottomTabList()
	self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 60.5, 720, 121);
    self.showBg.anchor = Lua_WindowUtil.getAnchor(7);
    self.showBg.siblingIndex = 11;

	self.tabInfo = Array();
    self.tabInfo:add({ textAtlas = "openServer_atlas", textNormalSprite = "xui_qrmb_zgnbutton_02_n", textSelectedSprite = "xui_qrmb_zgnbutton_02_p", redPointId = Lua_RedPointList.OpenServerCarnival_First});
    self.tabInfo:add({ textAtlas = "openServer_atlas", textNormalSprite = "xui_qrmb_zgnbutton_01_n", textSelectedSprite = "xui_qrmb_zgnbutton_01_p", redPointId = Lua_RedPointList.OpenServerCarnival_Second});

    self.tabBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.tabBtnList:setRectAnchor(7);
    self.tabBtnList:setLocation(240, 54, 0);
    self.tabBtnList.pivot = -1;
    self.tabBtnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
    self.tabBtnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
    self.tabBtnList:setButtonItem(120, 108);
    self.tabBtnList:setRedPoint(42, 41);
    self.tabBtnList:setClickCallBack(self, self.onTabBtnClick);
    self.tabBtnList:setData(self.tabInfo);
    self.tabBtnList:setEnable(false);
end

function Lua_OpenServerCarnivalWindow:onScreenResize()
	self:superCall("onScreenResize");

	-- self.rewardBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1335 + self.adaptHeight);
	self.taskBg:SetDimensions(689, 673 + self.adaptHeight);
	self.itemList:setContentRect(665, 647 + self.adaptHeight);
end

function Lua_OpenServerCarnivalWindow:updateServerInfo()
	-- 首次打开 
	if self.selectDay == nil then
		self.remainTime = DataCenter.openServerCarnivalData.closeTick;
		self:startTimer();

		local selectDay, actIndex = DataCenter.openServerCarnivalData:getSelectedDayByTab();
		local hasActCount = DataCenter.openServerCarnivalData.hasActCount;
		self.tabBtnList:setEnable(hasActCount == 2);
		self.tabBtnList:setSelected(actIndex);
	else
		self:updatePanelByTab();
	end
end

function Lua_OpenServerCarnivalWindow:updatePanelByTab(bPlayTween)
	local curProcess = DataCenter.openServerCarnivalData:getTotalCompletedTask(self.actIndex);
	self.totalProgressBar:setMaxValue(self.curTasksCount);
    self.totalProgressBar:setValue(curProcess);
    
    self.totalProgressBar:setText(curProcess .."/".. self.curTasksCount);
	
	-- 天数按钮
	local dayIdList = DataCenter.openServerCarnivalData:getDayIdListByTab(self.actIndex);
	local listIndex = DataCenter.openServerCarnivalData:getDayIndex(self.actIndex, self.selectDay);
	self.dayButtons:setData(dayIdList);
	self.dayButtons:setSelected(listIndex);
	self.dayButtons:moveToIndex(listIndex, true);

    self:updateDayTask(nil, bPlayTween);
end

--根据第几天显示该天的任务列表等
function Lua_OpenServerCarnivalWindow:updateDayTask(day, bPlayTween)
	if day ~= nil and self.selectDay == day then
		return;
	end

	if day ~= nil then
		self.selectDay = day;
	end
	
	local dayVo = DataCenter.openServerCarnivalData:getDayConfigById(self.selectDay);
	if dayVo == nil then
		return;
	end
    local curProcess = DataCenter.openServerCarnivalData:getCompletedTaskCountByDay(self.selectDay);
    local totalProcess = dayVo.dayTaskCount;
    self.dayProgressBar:setMaxValue(totalProcess);
    self.dayProgressBar:setValue(curProcess);
    self.dayProgressBar:setText(curProcess .."/".. totalProcess);

    local dayCountTxt = DataCenter.openServerCarnivalData:getDayTxtByDayId(self.selectDay);
    self.dayTxt.text = LanUtil.formateStr(308000, convert_arab_to_chinese(dayCountTxt, true));
    self.dayTasNumTxt.text = LanUtil.formateStr(308001, convert_arab_to_chinese(dayCountTxt, true));

	local reward = dayVo.rewardItems;
	self.dayReward:setData(reward[1]);

	local taskList = dayVo.taskIdList;
	table.sort( taskList, function (a, b)
			local aVo = DataCenter.openServerCarnivalData:getTaskConfigById(a);
			local bVo = DataCenter.openServerCarnivalData:getTaskConfigById(b);
			if aVo == nil or bVo == nil then return; end
			local aState = aVo.rewardState;
			local bState = bVo.rewardState;

			-- 不可领：0        可领取：1            已领取：2
			-- id - 0 + 0      id - 10000 + 0       id - 0 + 1000
			local aWeight = a - aState % 2 *10000 + Mathf.Floor( aState / 2) * 1000;
			local bWeight = b - bState % 2 *10000 + Mathf.Floor( bState / 2) * 1000;
			return aWeight < bWeight;
		end
		);
	self.itemList:setArrayData(taskList);
	self.itemList:moveToIndex(1,true);
	self.itemList.canDrag = not self.itemList.isTheEnd;
	if bPlayTween and self.bAgain then
		self.itemList.showTween = true;
		self.itemList:playTween();
	end
	self.bAgain = true;

	-- 最终奖励
	local finishId = DataCenter.openServerCarnivalData:getFinishRewardByTab(self.actIndex);
	local finishVo = DataCenter.openServerCarnivalData:getDayConfigById(finishId);
	local reward = finishVo.rewardItems;
	self.finishReward:setData(reward[1]);
end

function Lua_OpenServerCarnivalWindow:onTabBtnClick(tab)
	if self.actIndex == tab then
		return;
	end

	-- self.selectDay:活动第几天id,    self.actIndex:活动第几期       self.curTasksCount:活动第几期任务总数
	self.actIndex = tab;
	self.selectDay = DataCenter.openServerCarnivalData:getSelectedDayByTab(tab);
	self.curTasksCount = DataCenter.openServerCarnivalData:getTotalTaskCountByTab(self.actIndex);
	self:updateWinBg(tab == 1);
	self:updateDayBtnAndFinishReward();
	self:updatePanelByTab(true);
end

function Lua_OpenServerCarnivalWindow:updateWinBg(bShowFirst)
	self.winBg:setUrl(bShowFirst and self.firstWinBgPath or self.secondWinBgPath);
	local str = bShowFirst and 7 or 14;
	self.tipTxt.text = LanUtil.formateStr(308008, str);

	if bShowFirst then
		self.heroNameSp:setAltas("openServer_atlas", "xui_qemb_title_01");
		self.heroNameSp:setLocation(33, -288);
	else
		self.heroNameSp:setAltas("openServer_atlas", "xui_qemb_title_02");
		self.heroNameSp:setLocation(49, -288);
	end
end

function Lua_OpenServerCarnivalWindow:updateDayBtnAndFinishReward()
	-- 天数按钮
	local dayIdList = DataCenter.openServerCarnivalData:getDayIdListByTab(self.actIndex);
	local listIndex = DataCenter.openServerCarnivalData:getDayIndex(self.actIndex, self.selectDay);
	self.dayButtons:setData(dayIdList);
	-- self.dayButtons:moveToIndex(listIndex, true);
	self.dayButtons:setSelected(listIndex);	
end

function Lua_OpenServerCarnivalWindow:startTimer()
	if self.countDown == nil or self.countDown == false then
		Lua_CommonUtil.addTimer("updateLeftTime", 1, self, self.updateLeftTime);
		self.countDown = true;
		self:updateLeftTime();
	end
end

function Lua_OpenServerCarnivalWindow:updateLeftTime()
	local residueTime = self.remainTime - DataCenter.roleData.serverTime;
	if residueTime <= 0 then
		Lua_ProxyManager.getProxy("Lua_OpenServerCarnivalProxy"):sOpenServerCarnivalInfo(); -- 倒计时结束时向服务端发送请求，确认活动是否结束
		self.leftTimeTxt:setLangValue(308002);
		self:endTimer();
	elseif residueTime < 60 then
		self.leftTimeTxt.text = LanUtil.formateStr(308003, residueTime);
	else
		self.leftTimeTxt.text = LanUtil.formateStr(308004, Lua_TimeTransform.transSeconds16(residueTime, true, true, true, false));
	end
end

function Lua_OpenServerCarnivalWindow:endTimer()
	if self.countDown ~= nil and self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_OpenServerCarnivalWindow:dispose()
	self:endTimer();
	if self.finishReward ~= nil then
		self.finishReward:dispose();
		self.finishReward = nil;
	end
	if self.dayReward ~= nil then
		self.dayReward:dispose();
		self.dayReward = nil;
	end
	if self.dayButtons ~= nil then
		self.dayButtons:dispose();
		self.dayButtons = nil;
	end
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.tabBtnList ~= nil then
		self.tabBtnList:dispose();
		self.tabBtnList = nil;
	end

	self:superCall("dispose");
end
























----------------------------任务cell----------------------------------
Lua_OpenServerCarnivalTaskCell = class("Lua_OpenServerCarnivalTaskCell", Lua_ListCell);
function Lua_OpenServerCarnivalTaskCell:ctor(p)
    self:superCall("ctor", p, "OpenServerCarnivalItem_skin");
end

function Lua_OpenServerCarnivalTaskCell:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardWid = 124 * 0.7; 
	self.rewardList = Lua_DragList.new(self.content, self.rewardWid * 2, self.rewardWid, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_OpenServerCarnivalTaskRewardCell, self.rewardWid, self.rewardWid, 1);
	self.rewardList:setCellSpacing(17, 0);
	self.rewardList:setLocation(92, -5);
	self:setSubList(self.rewardList);

	self.stateSp:addClickFuntion(self, self.onBtnClick)
end

function Lua_OpenServerCarnivalTaskCell:setData(data)
	if data == nil then
		return;
	end

	self.data = data;

	local taskVo = DataCenter.openServerCarnivalData:getTaskConfigById(data);
	self.funcPathId = taskVo.funcPathId;
	self.rewardState = tonumber(taskVo.rewardState);

	self.taskTitleTxt.text = taskVo.title;
	self.taskContentTxt.text = taskVo.description;
	self.ProgressBar:setMaxValue(taskVo.process);
    self.ProgressBar:setValue(taskVo.curProcess);
    self.ProgressBar:setText(taskVo.curProcess .."/".. taskVo.process);

    local rewardLists = taskVo.rewardLists;
	if #rewardLists <= 1 then
		self.rewardList:setContentRect(self.rewardWid, self.rewardWid);
		self.rewardList:setLocation(67, 2);
	else
		self.rewardList:setContentRect(self.rewardWid * 2 + 17, self.rewardWid);
		self.rewardList:setLocation(15, 2);
	end
	self.rewardList.canDrag = #rewardLists > 2;
	self.rewardList:setArrayData(rewardLists);	



	if self.rewardState == 1 then
		self.stateSp:setAltas("common_altas_1", "xui_common_button_006_n");
		self.stateTxt:setLangValue(308005);
		self.stateTxt.colorStr = Lua_ColorDefine.transColorStr("8A5A37");
	elseif self.rewardState == 0 then
		self.stateSp:setAltas("common_altas_1", "xui_common_button_007_n");
		self.stateTxt:setLangValue(308006);
		self.stateTxt.colorStr = Lua_ColorDefine.transColorStr("74604F");
	else
		self.stateTxt.text = nil;
	end
	
	self.stateSp:setEnable( self.rewardState ~= 2);
	self.receivedSp:setEnable( self.rewardState == 2);
	self.ProgressBar:setEnable( self.rewardState ~= 2);
	self:showRedDot(self.rewardState == 1);
end

function Lua_OpenServerCarnivalTaskCell:onBtnClick()
	-- 活动已结束
	local isClose = DataCenter.openServerCarnivalData.isCloseAct;
	if isClose then
		Lua_WindowUtil.openWin("Lua_OpenServerCarnivalWindow", Lua_WinParam.ACTION_CLOSE);
		OperateAlert.showLangValue(107706);
		return;
	end

	-- 点击间隔
	local canPress = DataCenter.openServerCarnivalData.canPressByTime;
	if not canPress then
		OperateAlert.showLangValue(308009);
		return;
	end

	if self.rewardState == 0 then
		if self.funcPathId ~= nil then
			DataCenter.funcPathUtil:gotoFunction(self.funcPathId, true)
		end
	elseif self.rewardState == 1 then
		Lua_ProxyManager.getProxy("Lua_OpenServerCarnivalProxy"):sReceiveOpenServerCarnivalReward(self.data);
	end
end

function Lua_OpenServerCarnivalTaskCell:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(294, 42, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_OpenServerCarnivalTaskCell:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end

	self:superCall("dispose");
end




----------------------------任务奖励cell----------------------------------
Lua_OpenServerCarnivalTaskRewardCell = class("Lua_OpenServerCarnivalTaskRewardCell", Lua_ListCell);
function Lua_OpenServerCarnivalTaskRewardCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_OpenServerCarnivalTaskRewardCell:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardIcon = Lua_ItemIcon.new(self.content);
	self.rewardIcon:setScale(0.7, 0.7);
	-- self.rewardIcon:setCanClick(true);
	-- :setDrawMask(bState)
end

function Lua_OpenServerCarnivalTaskRewardCell:setData(data)
	if data == nil then
		return;
	end

	self.data = data;
	self.tvo = Lua_ToolVo.createToolVo(self.data[1], self.data[2]);
	self.rewardIcon:setData(self.tvo);
end

function Lua_OpenServerCarnivalTaskRewardCell:onPressClick()
	if self.data == nil then
		return;
	end
	
	DataCenter.packUtil:showItemInfo(self.tvo);
end

function Lua_OpenServerCarnivalTaskRewardCell:dispose()
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end

	self:superCall("dispose");
end
















----------------------------每天奖励及总奖励cell----------------------------------
Lua_OpenServerCarnivalRewardCell = class("Lua_OpenServerCarnivalRewardCell", Lua_DisplayObject);
function Lua_OpenServerCarnivalRewardCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_OpenServerCarnivalRewardCell:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardIcon = Lua_ItemIcon.new(self.content);
	self.rewardIcon:setClick(self, self.onPressClick);
	-- self.rewardIcon:setScale(0.7, 0.7);
	-- :setDrawMask(bState)
end

function Lua_OpenServerCarnivalRewardCell:setRewardScale(scaleValue)
	self.rewardIcon:setScale(scaleValue, scaleValue);
end

function Lua_OpenServerCarnivalRewardCell:setData(data)
	if data == nil then
		return;
	end

	self.data = data;
	self.tvo = Lua_ToolVo.createToolVo(self.data.reward[1], self.data.reward[2]);
	self.rewardIcon:setData(self.tvo);
	if type(self.data.id) ~= "number" then
		self:setRewardScale(0.7);
	else
		self:setRewardScale(0.9);
	end

	local vo = DataCenter.openServerCarnivalData:getDayConfigById(self.data.id);
	self.rewardIcon:setDrawMask(vo.rewardState == 2);
	self:showRedDot(vo.rewardState == 1);
end

function Lua_OpenServerCarnivalRewardCell:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			local posX, posY;
			if type(self.data.id) ~= "number" then 
				posX, posY = 36, 41;
			else
				posX, posY = 45, 46;
			end
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(posX, posY, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_OpenServerCarnivalRewardCell:onPressClick()
	if self.data == nil then
		return;
	end

	-- 活动已结束
	local isClose = DataCenter.openServerCarnivalData.isCloseAct;
	if isClose then
		Lua_WindowUtil.openWin("Lua_OpenServerCarnivalWindow", Lua_WinParam.ACTION_CLOSE);
		OperateAlert.showLangValue(107706);
		return;
	end

	-- 点击间隔
	local canPress = DataCenter.openServerCarnivalData.canPressByTime;
	if not canPress then
		OperateAlert.showLangValue(308009);
		return;
	end

	local vo = DataCenter.openServerCarnivalData:getDayConfigById(self.data.id);
	if vo == nil then return; end

	if vo.rewardState == 1 then
		Lua_ProxyManager.getProxy("Lua_OpenServerCarnivalProxy"):sReceiveOpenServerCarnivalReward(self.data.receiveId);
	else	
		DataCenter.packUtil:showItemInfo(self.tvo);
	end
end

function Lua_OpenServerCarnivalRewardCell:dispose()
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	

	self:superCall("dispose");
end





























----------------------------按钮Cell----------------------------------
Lua_OpenServerCarnivalBtnCell = class("Lua_OpenServerCarnivalBtnCell", Lua_ButtonCell);
function Lua_OpenServerCarnivalBtnCell:ctor(p)
    self:superCall("ctor", p, "OpenServerCarnivalBtnItem_skin");
end

function Lua_OpenServerCarnivalBtnCell:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_OpenServerCarnivalBtnCell:setData(data)
	if data == nil then
		return;
	end
	self.id = data;

	self.showDayNum = DataCenter.openServerCarnivalData:getDayTxtByDayId(data); -- 显示的天数：第几天
	self.btnTxt.text = LanUtil.formateStr(308000, convert_arab_to_chinese(self.showDayNum, true));

	local isShowRedPoint = false;
	if not isShow then 
		local hasReward = DataCenter.openServerCarnivalData:enableReceiveRewardByDay(data);
		local dayVo = DataCenter.openServerCarnivalData:getDayConfigById(data);
		local hasDayReward = dayVo.rewardState == 1;
		isShowRedPoint = hasReward or hasDayReward;
	end
	self:showRedDot(isShowRedPoint and not (self.showDayNum > DataCenter.openServerCarnivalData.openDay));
	self:updateBtnState();
end

function Lua_OpenServerCarnivalBtnCell:updateBtnState()
	local isShow = DataCenter.openServerCarnivalData.openDay < self.showDayNum;
	if isShow then
		self.btnSp:setAltas("common_altas_4", "xui_common_button_033_d");
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("8D8D8D");
	else
		self.btnSp:setAltas("common_altas_4", "xui_common_button_033_n");
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("5E4D3F");
	end
end

function Lua_OpenServerCarnivalBtnCell:setSelected(index)
    if index == self.index then -- 选中
        self.btnSp:setAltas("common_altas_4", "xui_common_button_033_p");
        self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("83552E");
    else
        self:updateBtnState();
    end
end

function Lua_OpenServerCarnivalBtnCell:setCanClick(bCan)
    if bCan == true then
        self.btnSp.mouseEnable = true
        self.btnSp:addClickFuntion(self, self.onPressClick)
    else
        self.btnSp.mouseEnable = false
        self.btnSp:removeClickFuntion(self, self.onPressClick)
    end
end

-- 红点
function Lua_OpenServerCarnivalBtnCell:showRedDot(val)
    if val == true then
        if self.redPoint == nil then
            self.redPoint = Lua_RedPointIcon.new(self.content);
            self.redPoint:setLocation(61, 21, 0);
            self.redPoint:createRedPointEff();
        end
        self.redPoint:updateRedPointShow(true);
    else
        if self.redPoint ~= nil then
            self.redPoint:updateRedPointShow(false);
        end
    end
end

function Lua_OpenServerCarnivalBtnCell:onPressClick()
	if self.id == nil then
		return;
	end

	-- 活动已结束
	local isClose = DataCenter.openServerCarnivalData.isCloseAct;
	if isClose then
		Lua_WindowUtil.openWin("Lua_OpenServerCarnivalWindow", Lua_WinParam.ACTION_CLOSE);
		OperateAlert.showLangValue(107706);
		return;
	end

	if self.showDayNum > DataCenter.openServerCarnivalData.openDay then
		OperateAlert.showLangValue(308007);
		return ;
	end
 	self:superCall("onPressClick", go);
end

function Lua_OpenServerCarnivalBtnCell:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end

	self:superCall("dispose");
end